%define _hardened_build 1
Summary: GUI for several command-line debuggers
Name: ddd
Version: 3.4.0
Release:    2%{?dist}
License: GPL-2.0-or-later
URL: http://www.gnu.org/software/ddd/
Source0: https://ftp.gnu.org/gnu/ddd/ddd-%{version}.tar.gz
Source2: ddd.png
Patch0: ddd-3.3.12-debuginfo.patch

Requires: gdb, xterm, gnuplot, xdg-utils, xorg-x11-fonts-ISO8859-1-75dpi, xorg-x11-fonts-ISO8859-1-100dpi, xclipboard, xfontsel
BuildRequires:  gcc-c++
BuildRequires: motif-devel, ncurses-devel, libXaw-devel
BuildRequires: elfutils-libelf-devel, xterm 
BuildRequires: desktop-file-utils, gdb, readline-devel, texinfo, autoconf, automake
BuildRequires: make

%description
The Data Display Debugger (DDD) is a popular GUI for command-line
debuggers like GDB, DBX, JDB, WDB, XDB, the Perl debugger, and the
Python debugger. DDD allows you to view source texts and provides an
interactive graphical data display, in which data structures are
displayed as graphs. You can use your mouse to dereference pointers
or view structure contents, which are updated every time the program
stops. DDD can debug programs written in Ada, C, C++, Chill, Fortran,
Java, Modula, Pascal, Perl, and Python. DDD provides machine-level
debugging; hypertext source navigation and lookup; breakpoint,
watchpoint, backtrace, and history editors; array plots; undo and
redo; preferences and settings editors; program execution in the
terminal emulation window, debugging on a remote host, an on-line
manual, extensive help on the Motif user interface, and a command-line
interface with full editing, history and completion capabilities.

%prep
%setup -q
%patch -P 0 -p1

%build
export CXXFLAGS="${RPM_OPT_FLAGS} -fpermissive"
%configure --with-readline --disable-dependency-tracking
make %{?_smp_mflags}

%install
make DESTDIR=%{buildroot} install

rm -f %{buildroot}/%{_infodir}/dir*

desktop-file-install \
        --dir %{buildroot}%{_datadir}/applications \
        --add-category X-Fedora \
        ddd/ddd.desktop

install -D -m 0644 %{SOURCE2} \
    %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/ddd.png

%files
%license COPYING*
%doc AUTHORS CREDITS
%doc INSTALL NEWS README TIPS
%{_bindir}/ddd
%{_datadir}/applications/*.desktop
%{_datadir}/%{name}-%{version}/COPYING
%{_datadir}/%{name}-%{version}/NEWS
%config(noreplace) %{_datadir}/%{name}-%{version}/ddd/Ddd
%{_datadir}/%{name}-%{version}/themes/
%{_datadir}/%{name}-%{version}/vsllib/
%{_datadir}/icons/hicolor/48x48/apps/ddd.png
%{_infodir}/ddd*
%{_mandir}/man1/ddd.1*

%changelog
* Wed Jun 04 2025 bbrucezhang <bbrucezhang@tencent.com> - 3.4.0-2
- Rebuilt for loongarch64

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.0-1
- initial build
